## ndiswrapper 1.52

=== driver/Makefile ===
DISTFILES=divdi3.c hal.c iw_ndis.c iw_ndis.h loader.c loader.h \
		longlong.h Makefile crt.c ndis.c ndis.h \
		ndiswrapper.h ntoskernel.c ntoskernel.h ntoskernel_io.c \
		pe_linker.c pe_linker.h pnp.c pnp.h proc.c rtl.c usb.c usb.h \
		winnt_types.h workqueue.c wrapmem.h wrapmem.c wrapper.c \
		wrapndis.h wrapndis.c lin2win.h win2lin_stubs.S

# By default, we try to compile the modules for the currently running
# kernel.  But it's the first approximation, as we will re-read the
# version from the kernel sources.
KVERS ?= $(shell uname -r)

# KBUILD is the path to the Linux kernel build tree.  It is usually the
# same as the kernel source tree, except when the kernel was compiled in
# a separate directory.
KBUILD ?= $(shell readlink -f /lib/modules/$(KVERS)/build)

# Some old kernels only install the "source" link
ifeq (,$(KBUILD))
KBUILD := $(shell readlink -f /lib/modules/$(KVERS)/source)
endif

ifeq (,$(KBUILD))
$(error Kernel tree not found - please set KBUILD to configured kernel)
endif

# Kernel Makefile doesn't always know the exact kernel version, so we
# get it from the kernel headers instead and pass it to make.

VERSION_H := $(KBUILD)/include/linux/utsrelease.h
ifeq (,$(wildcard $(VERSION_H)))
VERSION_H := $(KBUILD)/include/linux/version.h
endif
ifeq (,$(wildcard $(VERSION_H)))
$(error Cannot find kernel version in $(KBUILD), is it configured?)
endif

KVERS := $(shell sed -ne 's/"//g;s/^\#define UTS_RELEASE //p' $(VERSION_H))
KPSUB := $(shell echo $(KVERS) | sed -e 's/\([^\.]*\)\.\([^\.]*\)\..*/\1\2/')

# distros use different paths for kernel include files

KSRC ?= $(shell if \
	[ -f /lib/modules/$(KVERS)/source/include/linux/kernel.h ]; then \
		echo /lib/modules/$(KVERS)/source ; \
	else \
		echo $(KBUILD); \
	fi)

ifdef DIST_DESTDIR
DESTDIR = $(DIST_DESTDIR)
else
DESTDIR ?= /
endif

INST_DIR ?= $(shell echo $(DESTDIR)/lib/modules/$(KVERS)/misc | sed 's^//^/^g')

SRC_DIR=$(shell pwd)

KREV := $(shell echo $(KVERS) | sed -e 's/[^\.]*\.[^\.]*\.\([0-9]*\).*/\1/')

KCONFIG := $(KBUILD)/.config
ifeq (,$(wildcard $(KCONFIG)))
$(error No .config found in $(KBUILD), please set KBUILD to configured kernel)
endif
include $(KBUILD)/.config

MOD_CFLAGS += $(shell [ -f $(KSRC)/include/linux/modversions.h ] && \
		  echo -DEXPORT_SYMTAB -DMODVERSIONS \
		  -include $(KSRC)/include/linux/modversions.h)

ifndef DISABLE_USB
MOD_CFLAGS += $(shell if grep -q 'struct module \*owner;' \
		   $(KSRC)/include/linux/usb.h ; then \
			echo -DUSB_DRIVER_OWNER; \
		  fi)
endif

# returns of structs and unions in registers when possible, like Windows 
MOD_CFLAGS += -freg-struct-return

# to produce debug trace, add option "DEBUG=<n>" where <n> is 1 to 6
ifdef DEBUG
MOD_CFLAGS += -DDEBUG=$(DEBUG) -g
endif

# to debug timers, add option "TIMER_DEBUG=1 DEBUG=<n>"
ifdef TIMER_DEBUG
MOD_CFLAGS += -DTIMER_DEBUG
endif

# to debug event layer, add option "EVENT_DEBUG=1 DEBUG=<n>"
ifdef EVENT_DEBUG
MOD_CFLAGS += -DEVENT_DEBUG
endif

# to debug USB layer, add option "USB_DEBUG=1 DEBUG=<n>"
ifdef USB_DEBUG
MOD_CFLAGS += -DUSB_DEBUG
endif

# to debug I/O layer, add option "IO_DEBUG=1 DEBUG=<n>"
ifdef IO_DEBUG
MOD_CFLAGS += -DIO_DEBUG
endif

# to debug worker threads
ifdef WORK_DEBUG
MOD_CFLAGS += -DWORK_DEBUG
endif

# to debug memory allocation issues
ifdef ALLOC_DEBUG
MOD_CFLAGS += -DALLOC_DEBUG=$(ALLOC_DEBUG)
endif

# emulate (pseudo) preemption
ifdef WRAP_PREEMPT
MOD_CFLAGS += -DWRAP_PREEMPT
endif

.PHONY: prereq_check gen_exports clean dist_clean install stack_check

all : prereq_check win2lin_stubs.h gen_exports compat.h default stack_check

OBJS := crt.o hal.o iw_ndis.o loader.o ndis.o ntoskernel.o ntoskernel_io.o \
	pe_linker.o pnp.o proc.o rtl.o wrapmem.o wrapndis.o wrapper.o

# by default, USB layer is compiled in if USB support is in kernel;
# to disable USB support in ndiswrapper even if USB support is in kenrel,
# add option "DISABLE_USB=1"

ifdef DISABLE_USB
usb_exports.h:

MOD_CFLAGS += -DDISABLE_USB
else
usb_exports.h: usb.c

ifeq ($(CONFIG_USB),y)
OBJS += usb.o
endif
ifeq ($(CONFIG_USB),m)
OBJS += usb.o
endif
endif

MOD_CFLAGS += $(shell if grep -s -A1 'ndiswrapper' $(KSRC)/kernel/module.c | \
			grep -q 'add_taint_module' ; then \
			echo -DUSE_OWN_WQ; \
		  fi)

ifdef WRAP_WQ
MOD_CFLAGS += -DWRAP_WQ
OBJS += workqueue.o
endif

ifdef NTOS_WQ
MOD_CFLAGS += -DNTOS_WQ
endif

ntoskernel.h: lin2win.h

ndis.h: ntoskernel.h

iw_ndis.h: ntoskernel.h

pnp.h: ntoskernel.h ndis.h

wrapndis.h: ndis.h pnp.h

usb.h: ntoskernel.h

divdi3.o: divdi3.c longlong.h

hal.o: hal.c ntoskernel.h

iw_ndis.o: iw_ndis.c iw_ndis.h wrapndis.h

loader.o: loader.c loader.h ndis.h wrapndis.h

crt.o: crt.c ndis.h

ndis.o: ndis.c ndis.h iw_ndis.h wrapndis.h

wrapndis.o: wrapndis.c wrapndis.h

ntoskernel.o: ntoskernel.c ndis.h usb.h

ntoskernel_io.o: ntoskernel_io.c ndis.h usb.h

pe_linker.o: pe_linker.c

pnp.o: pnp.c

proc.o: proc.c ndis.h iw_ndis.h wrapndis.h

rtl.o: rtl.c ndis.h

usb.o: usb.c usb.h ndis.h

wrapper.o: wrapper.c wrapndis.h iw_ndis.h ntoskernel.h loader.h

ifeq ($(CONFIG_X86_64),y)
OBJS += win2lin_stubs.o
win2lin_stubs.o: win2lin_stubs.h win2lin_stubs.S

ifdef DISABLE_USB
win2lin_stubs.h: hal.c crt.c ndis.c ntoskernel.c ntoskernel_io.c \
	pnp.c rtl.c wrapndis.c
else
win2lin_stubs.h: hal.c crt.c ndis.c ntoskernel.c ntoskernel_io.c \
	pnp.c rtl.c usb.c wrapndis.c
endif
	@for file in $^; do \
		echo; \
		echo "# automatically generated from $$file"; \
		sed -n \
			-e 's/.*WIN_FUNC(\([^\,]\+\) *\, *\([0-9]\+\)).*/\
			   win2lin(\1, \2)/p'   \
			-e 's/.*WIN_FUNC_PTR(\([^\,]\+\) *\, *\([0-9]\+\)).*/\
			   win2lin(\1, \2)/p'   \
		   $$file | sed -e 's/[ \t	]\+//' | sort -u; \
	done > $@
else
win2lin_stubs.h:

OBJS += divdi3.o
endif

# generate exports symbol table from C files
%_exports.h: %.c
	@if :; then \
		echo "/* automatically generated from $< */"; \
		echo "#ifdef CONFIG_X86_64"; \
		sed -n \
			-e 's/.*WIN_FUNC(\([^\,]\+\) *\, *\([0-9]\+\)).*/\
			   WIN_FUNC_DECL(\1, \2)/p' \
			-e 's/.*WIN_FUNC_PTR(\([^\,]\+\) *\, *\([0-9]\+\)).*/\
			   WIN_FUNC_DECL(\1, \2)/p' \
		   $< | sed -e 's/[ \t	]\+//' | sort -u; \
		echo "#endif"; \
		echo "struct wrap_export $(basename $<)_exports[] = {";\
		sed -n \
			-e 's/.*WIN_FUNC(_win_\([^\,]\+\) *\, *\([0-9]\+\)).*/\
				WIN_WIN_SYMBOL(\1,\2),/p' \
			-e 's/.*WIN_FUNC(\([^\,]\+\) *\, *\([0-9]\+\)).*/\
				WIN_SYMBOL(\1,\2),/p' \
			-e 's/.*WIN_SYMBOL_MAP(\("[^"]\+"\)[ ,\n]\+\([^)]\+\)).*/\
				{\1,(generic_func)\2},/p'  \
			   $< | sed -e 's/[ \t	]*/   /' | sort -u; \
		echo "   {NULL, NULL}"; \
		echo "};"; \
	fi > $@

gen_exports: crt_exports.h ndis_exports.h hal_exports.h ntoskernel_exports.h \
			 ntoskernel_io_exports.h rtl_exports.h usb_exports.h

compat.h: $(KBUILD)/include/linux/version.h
	@echo "/* this file is automatically generated */" > $@
	@if ! grep -qw kzalloc $(KSRC)/include/linux/slab.h; then \
		echo "static inline void *kzalloc(size_t size, unsigned long flags)"; \
		echo "{ void *ret = kmalloc(size, flags);"; \
		echo "if (ret) memset(ret, 0, size); return ret;}"; \
	fi >> $@
	@if [ -f $(KSRC)/include/linux/netdevice.h ]; then \
		echo "#include <linux/netdevice.h>"; \
	fi >> $@
	@if ! grep -qw netif_tx_lock $(KSRC)/include/linux/netdevice.h; then \
		echo "static inline void netif_tx_lock(struct net_device *dev)"; \
		echo "{ spin_lock(&dev->xmit_lock); }"; \
		echo "static inline void netif_tx_unlock(struct net_device *dev)"; \
		echo "{ spin_unlock(&dev->xmit_lock); }"; \
		echo "static inline void netif_tx_lock_bh(struct net_device *dev)"; \
		echo "{ spin_lock_bh(&dev->xmit_lock); }"; \
		echo "static inline void netif_tx_unlock_bh(struct net_device *dev)"; \
		echo "{ spin_unlock_bh(&dev->xmit_lock); }"; \
	fi >> $@
	@if ! grep -qw netif_poll_enable $(KSRC)/include/linux/netdevice.h; then \
	    echo "static inline void netif_poll_enable(struct net_device *dev) {}"; \
	    echo "static inline void netif_poll_disable(struct net_device *dev) {}"; \
	fi >> $@
	@if ! grep -qw pci_set_consistent_dma_mask \
			   $(KSRC)/include/linux/pci.h; then \
		echo "static inline int pci_set_consistent_dma_mask" ; \
		echo "(struct pci_dev *dev, u64 mask) { return 0; }" ; \
	fi >> $@
	@if ! grep -qw create_workqueue $(KSRC)/include/linux/*.h; then \
		echo "#define WRAP_WQ 1"; \
	fi >> $@
	@if ! grep -qw create_workqueue $(KSRC)/include/linux/*.h; then \
		echo "#define WRAP_WQ 1"; \
	fi >> $@
	@if [ -f $(KSRC)/include/linux/percpu.h ]; then \
		echo "#include <linux/percpu.h>"; \
	fi >> $@
	@if grep -qw proc_net $(KSRC)/include/linux/proc_fs.h; then \
		echo "#define proc_net_root proc_net"; \
     else \
		echo "#define proc_net_root init_net.proc_net"; \
	fi >> $@

prereq_check:
	@if [ ! -f $(KBUILD)/include/linux/version.h ]; then \
		echo "Can't find kernel build files in $(KBUILD);"; \
		echo "  give the path to kernel build directory with " ; \
		echo "  KBUILD=<path> argument to make";\
		exit 1;\
	fi
	@if [ ! -f $(KSRC)/include/linux/kernel.h ]; then \
		echo "Can't find kernel build files in $(KSRC);"; \
		echo "  give the path to kernel build directory with " ; \
		echo "  KSRC=<path> argument to make";\
		exit 1;\
	fi

clean:
	rm -rf $(MODULE) ndiswrapper.o $(OBJS) usb.o win2lin_stubs.o \
	   divdi3.o workqueue.o .*.ko.cmd .*.o.cmd  compat.h \
	   ndiswrapper.mod.[oc] *~ .tmp_versions Modules.symvers Module.symvers

distclean: clean
	rm -f *_exports.h .\#* win2lin_stubs.h built-in.o

wflags := $(shell if grep -qw "EXTRA_CFLAGS" $(KSRC)/scripts/Makefile.build; \
		             then echo "EXTRA_CFLAGS"; else echo "CFLAGS"; fi)

ifeq ($(wflags), CFLAGS)
CFLAGS += $(MOD_CFLAGS)
else
EXTRA_CFLAGS += $(MOD_CFLAGS)
endif

MODULE := ndiswrapper.ko
obj-m := ndiswrapper.o 

ndiswrapper-objs := $(OBJS)

default:
	$(MAKE) -C $(KBUILD) SUBDIRS=$(SRC_DIR)


stack_check:
	@if [ "x$(CONFIG_X86_64)" = "x" -a $(KPSUB) -eq 26 ] && \
	       grep -q "CONFIG_4KSTACKS=y" $(KBUILD)/.config; then \
	    echo; echo; \
	    echo "*** WARNING: This kernel seems to use 4K stack size"\
		 "option (CONFIG_4KSTACKS); many Windows drivers will"\
		 "not work with this option enabled. Disable"\
		 "CONFIG_4KSTACKS option, recompile and install kernel";\
	    echo; echo; \
	fi

install: prereq_check win2lin_stubs.h gen_exports compat.h default stack_check
	echo $(INST_DIR)
	mkdir -p $(INST_DIR)
	install -m 0644 $(MODULE) $(INST_DIR)
	-@/bin/rm -rf $(SRC_DIR)/.tmp_versions
ifndef DIST_DESTDIR
	-/sbin/depmod -a $(KVERS) -b $(DESTDIR)
endif

dist:
	@for file in $(DISTFILES); do \
	  cp  $$file $(distdir)/$$file; \
	done

## ndiswrapper 1.56

=== Makefile ===
DRIVER_VERSION = $(shell sed -n 's/^\#define[ \t]\+DRIVER_VERSION[ \t]\+"\([^"]\+\)"/\1/p' driver/ndiswrapper.h)

UTILS_VERSION = $(shell sed -n 's/^\#define[ \t]\+UTILS_VERSION[ \t]\+"\([^"]\+\)"/\1/p' driver/ndiswrapper.h)

distdir=ndiswrapper-${DRIVER_VERSION}
distarchive=${distdir}.tar.gz

DISTFILES=AUTHORS ChangeLog INSTALL Makefile README ndiswrapper.spec \
				   ndiswrapper.8 loadndisdriver.8
DIST_SUBDIRS=utils driver

DESTDIR =
mandir = $(DESTDIR)$(shell [ -d /usr/man/man8 ] && echo /usr/man || echo /usr/share/man )

KVERS ?= $(shell uname -r)

.PHONY: all

all:
	+make -C driver
	+make -C utils

.PHONY: install
install:
	+make -C driver install
	+make -C utils install
	mkdir -p -m 0755 $(mandir)/man8
	install -m 644 ndiswrapper.8 $(mandir)/man8
	install -m 644 loadndisdriver.8 $(mandir)/man8

.PHONY: clean distclean
clean:
	+make -C driver clean
	+make -C utils clean
	rm -f *~
	rm -fr ${distdir} ${distdir}.tar.gz patch-stamp

distclean: clean
	+make -C driver distclean
	+make -C utils distclean
	rm -f .\#*

uninstall:
	@echo "NOTE: Not all installed files are removed, as different" \
		"distributions install ndiswrapper files at different places."
	@echo "Run uninstall as many times as necessary until no" \
		"\"removing\" messages appear below."
	@if [ "x$(shell which loadndisdriver)" != "x" ]; then \
		echo "removing $(shell which loadndisdriver)"; \
		/bin/rm -f $(shell which loadndisdriver); \
	fi
	@if [ "x$(shell which ndiswrapper)" != "x" ]; then \
		echo "removing $(shell which ndiswrapper)"; \
		/bin/rm -f $(shell which ndiswrapper); \
	fi
	@if [ "x$(shell which ndiswrapper-buginfo)" != "x" ]; then \
		echo "removing $(shell which ndiswrapper-buginfo)"; \
		/bin/rm -f $(shell which ndiswrapper-buginfo); \
	fi
	@for module in $(shell find /lib/modules/$(KVERS) -type f | \
			grep 'ndiswrapper.\(\(ko\)\|\(o\)\)'$); do \
		echo "removing $$module"; \
		/bin/rm -f $$module; \
	done

dist:
	@rm -rf ${distdir}
	mkdir -p ${distdir}
	@for file in $(DISTFILES); do \
	  cp  $$file $(distdir)/$$file; \
	done
	for subdir in $(DIST_SUBDIRS); do \
	  if test "$$subdir" = .; then :; else \
	    test -d $(distdir)/$$subdir \
	    || mkdir $(distdir)/$$subdir \
	    || exit 1; \
	  fi; \
	done
	+make -C driver distdir=../${distdir}/driver dist
	+make -C utils distdir=../${distdir}/utils dist

	# Update version in dist rpm spec file - don't crash if it fails
	-sed -i "s/\%define\s\+ndiswrapper_version\s\+[^\}]\+\}/%define ndiswrapper_version $(DRIVER_VERSION)\}/" $(distdir)/ndiswrapper.spec
	tar cfz ${distarchive} ${distdir}

rpm: dist ndiswrapper.spec
	rpmbuild -ta $(distarchive) --define="ndiswrapper_version $(DRIVER_VERSION)"

=== driver/Makefile ===
# Name of the module
MODNAME = ndiswrapper

DISTFILES = \
	Makefile crt.c divdi3.c hal.c iw_ndis.c iw_ndis.h lin2win.h loader.c \
	loader.h longlong.h mkexport.sh mkstubs.sh ndis.c ndis.h \
	ndiswrapper.h ntoskernel.c ntoskernel.h ntoskernel_io.c pe_linker.c \
	pe_linker.h pnp.c pnp.h proc.c rtl.c usb.c usb.h win2lin_stubs.S \
	winnt_types.h workqueue.c wrapmem.h wrapmem.c wrapper.c wrapper.h \
	wrapndis.c wrapndis.h

# By default, we try to compile the modules for the currently running
# kernel.  But it's the first approximation, as we will re-read the
# version from the kernel sources.
KVERS ?= $(shell uname -r)

# KBUILD is the path to the Linux kernel build tree.  It is usually the
# same as the kernel source tree, except when the kernel was compiled in
# a separate directory.
KBUILD := $(shell readlink -f /lib/modules/$(KVERS)/build)

ifeq (,$(KBUILD))
$(error Kernel tree not found - please set KBUILD to configured kernel)
endif

# Kernel Makefile doesn't always know the exact kernel version, so we
# get it from the kernel headers instead and pass it to make.

VERSION_H := $(KBUILD)/include/linux/utsrelease.h
ifeq (,$(wildcard $(VERSION_H)))
VERSION_H := $(KBUILD)/include/linux/version.h
endif
ifeq (,$(wildcard $(VERSION_H)))
$(error Cannot find kernel version in $(KBUILD), is it configured?)
endif

KVERS := $(shell sed -ne 's/"//g;s/^\#define UTS_RELEASE //p' $(VERSION_H))

ifdef DIST_DESTDIR
DESTDIR = $(DIST_DESTDIR)
else
DESTDIR ?= /
endif

INST_DIR ?= $(shell echo $(DESTDIR)/lib/modules/$(KVERS)/misc | sed 's^//^/^g')

SRC_DIR=$(shell pwd)

KCONFIG := $(KBUILD)/.config
ifeq (,$(wildcard $(KCONFIG)))
$(error No .config found in $(KBUILD), please set KBUILD to configured kernel)
endif
include $(KBUILD)/.config

# returns of structs and unions in registers when possible, like Windows
EXTRA_CFLAGS += -freg-struct-return

# to produce debug trace, add option "DEBUG=<n>" where <n> is 1 to 6
ifdef DEBUG
EXTRA_CFLAGS += -DDEBUG=$(DEBUG) -g
endif

# to debug timers, add option "TIMER_DEBUG=1 DEBUG=<n>"
ifdef TIMER_DEBUG
EXTRA_CFLAGS += -DTIMER_DEBUG
endif

# to debug event layer, add option "EVENT_DEBUG=1 DEBUG=<n>"
ifdef EVENT_DEBUG
EXTRA_CFLAGS += -DEVENT_DEBUG
endif

# to debug USB layer, add option "USB_DEBUG=1 DEBUG=<n>"
ifdef USB_DEBUG
EXTRA_CFLAGS += -DUSB_DEBUG
endif

# to debug I/O layer, add option "IO_DEBUG=1 DEBUG=<n>"
ifdef IO_DEBUG
EXTRA_CFLAGS += -DIO_DEBUG
endif

# to debug worker threads
ifdef WORK_DEBUG
EXTRA_CFLAGS += -DWORK_DEBUG
endif

# to debug memory allocation issues
ifdef ALLOC_DEBUG
EXTRA_CFLAGS += -DALLOC_DEBUG=$(ALLOC_DEBUG)
endif

# emulate (pseudo) preemption
ifdef WRAP_PREEMPT
EXTRA_CFLAGS += -DWRAP_PREEMPT
endif

OBJS = crt.o hal.o iw_ndis.o loader.o ndis.o ntoskernel.o ntoskernel_io.o \
	pe_linker.o pnp.o proc.o rtl.o wrapmem.o wrapndis.o wrapper.o

EXPORTS = crt_exports.h hal_exports.h ndis_exports.h ntoskernel_exports.h \
	ntoskernel_io_exports.h rtl_exports.h

STUB_SRCS = crt.c hal.c ndis.c ntoskernel.c ntoskernel_io.c \
	pnp.c rtl.c wrapndis.c


# By default, USB layer is compiled in if USB support is in kernel;
# to disable USB support in ndiswrapper even if USB support is in kenrel,
# add option "DISABLE_USB=1"
ifndef DISABLE_USB
ifeq ($(CONFIG_USB),y)
ENABLE_USB = 1
endif
ifeq ($(CONFIG_USB),m)
ENABLE_USB = 1
endif
endif

ifdef ENABLE_USB
EXPORTS += usb_exports.h
STUB_SRCS += usb.c
OBJS += usb.o
EXTRA_CFLAGS += -DENABLE_USB
endif

ifdef WRAP_WQ
EXTRA_CFLAGS += -DWRAP_WQ
OBJS += workqueue.o
endif


all: config_check modules

# generate exports symbol table from C files
quiet_cmd_mkexport = MKEXPORT $@
cmd_mkexport = $(SHELL) $(obj)/mkexport.sh $< $@

extra-y += $(EXPORTS)
%_exports.h: %.c $(obj)/mkexport.sh FORCE
	$(call if_changed,mkexport)

$(addprefix $(obj)/,$(EXPORTS:_exports.h=.o)): %.o: %_exports.h

ifeq ($(CONFIG_X86_64),y)
quiet_cmd_mkstubs = MKSTUBS $@
cmd_mkstubs = $(SHELL) $(obj)/mkstubs.sh $(addprefix $(src)/,$(STUB_SRCS)) >$@

extra-y += win2lin_stubs.h
$(obj)/win2lin_stubs.h: $(addprefix $(src)/,$(STUB_SRCS)) FORCE
	$(call if_changed,mkstubs)

$(obj)/win2lin_stubs.o: $(obj)/win2lin_stubs.h
OBJS += win2lin_stubs.o
else
OBJS += divdi3.o
endif

MODULE := $(MODNAME).ko
obj-m := $(MODNAME).o

$(MODNAME)-objs := $(OBJS)


config_check:
	@if [ ! -f $(KBUILD)/include/linux/version.h ]; then \
		echo; echo; \
		echo "Cannot find kernel build files in $(KBUILD)"; \
		echo "Please give the path to kernel build directory with" ; \
		echo "the KBUILD=<path> argument to make";\
		echo; echo; \
		exit 1; \
	fi
	@if [ -z "$(CONFIG_WIRELESS_EXT)$(CONFIG_NET_RADIO)" ]; then \
		echo; echo; \
		echo "*** WARNING: This kernel lacks wireless extensions."; \
		echo "Wireless drivers will not work properly."; \
		echo; echo; \
	fi
	@if [ -z "$(CONFIG_X86_64)" ] && [ -n "$(CONFIG_4KSTACKS)" ]; then \
		echo; echo; \
		echo "*** WARNING: This kernel uses 4K stack size option"; \
		echo "(CONFIG_4KSTACKS); many Windows drivers will not work"; \
		echo "with this option enabled. Disable CONFIG_4KSTACKS"; \
		echo "in kernel's .config file, recompile and install kernel"; \
		echo; echo; \
	fi

modules:
	$(MAKE) -C $(KBUILD) M=$(SRC_DIR)

clean:
	rm -f *.o *.ko .*.cmd *.mod.c *.symvers modules.order *~ .\#*
	rm -f *_exports.h win2lin_stubs.h
	rm -rf .tmp_versions

install: config_check modules
	echo $(INST_DIR)
	mkdir -p $(INST_DIR)
	install -m 0644 $(MODULE) $(INST_DIR)
ifndef DIST_DESTDIR
	-/sbin/depmod -a $(KVERS) -b $(DESTDIR)
endif

dist:
	@for file in $(DISTFILES); do \
		cp $$file $(distdir)/$$file; \
	done

.PHONY: all modules clean install config_check dist

=== debian/changelog ===
ndiswrapper (1.56-1) unstable; urgency=low

  * Imported Upstream version 1.56
  * Drop all patches, they are shipped upstream now.
  * debian/ndiswrapper.8, debian/loadnsisdriver.8: Escape the "-".

 -- Julian Andres Klode <jak@debian.org>  Sun, 14 Feb 2010 14:28:28 +0100

ndiswrapper (1.55-2) unstable; urgency=low

  * use-conf-in-modprobe-d.diff: Use /etc/modprobe.d/ndiswrapper.conf,
    not /etc/modprobe.d/ndiswrapper.
  * fix-cmpxchg8b.diff: Fix compilation for kernel >= 2.6.31 on i386
    (Closes: #568065).

 -- Julian Andres Klode <jak@debian.org>  Tue, 02 Feb 2010 08:21:45 +0100

ndiswrapper (1.55-1) unstable; urgency=low

  * Imported Upstream version 1.55
  * fix-typo-in-netdev-ops-struct.patch: Drop patch, now upstream.
  * debian/control: Increase Standards-Version to 3.8.4.
  * Create a ndiswrapper-dkms package, recommend it in ndiswrapper-
    utils-1.9.
  * debian/control: Add Vcs-Git and Vcs-Browser fields.
  * debian/control: Add ${misc:Depends} to ndiswrapper-source
    dependencies.
  * Switch to 3.0 (quilt) source package format.

 -- Julian Andres Klode <jak@debian.org>  Mon, 01 Feb 2010 18:35:25 +0100

ndiswrapper (1.54-2) unstable; urgency=low

  * Fix FTBFS with kernel 2.6.29 (Closes: #521212)
    - Patch by Stefan Lippers-Hollmann <s.L-H@gmx.de>
  * debian/control: Change section of ndiswrapper-source to "kernel".

 -- Julian Andres Klode <jak@debian.org>  Sat, 28 Mar 2009 17:55:43 +0100

ndiswrapper (1.54-1) unstable; urgency=low

  * New upstream release
    - Fixes building with Kernel 2.6.27 and newer (Closes: #519988)
  * Dropping all our patches, all included upstream
  * Upgrade to Policy 3.8.1, no changes required

 -- Julian Andres Klode <jak@debian.org>  Tue, 17 Mar 2009 18:35:09 +0100

ndiswrapper (1.53-2) unstable; urgency=high

  * Add debian/patches/CVE-2008-4395.patch to fix a vulnerability in handling
    of long ESSIDs which allows execution of code as root via remote attacker.
    (Closes: #504696)

 -- Kel Modderman <kel@otaku42.de>  Thu, 06 Nov 2008 21:06:38 +1000

ndiswrapper (1.53-1) unstable; urgency=low

  [ Kel Modderman ]
  * New upstream release. (Closes: #484019)
  * Include driver/*.sh in debianized ndiswrapper module tarball.
  * The distclean Makefile target no longer exists, use clean instead.
  * No longer need to define KSRC in debian/rules/modules, upstream Makefile
    requires only the KBUILD variable.
  * Major behaviour change in ndiswrapper-common wrappers for loadndisdriver
    and ndiswrapper utils:
    - check required utils_version attribute of currently installed
      ndiswrapper kernel module, use this version instead of latest version if
      called interactively
    - fallback to detection of latest API version when the information cannot
      be determined from the kernel module (not yet installed)
  * Remove dilinger from Uploaders as per his request.
  * Remove commented out quilt related code from debian/rules.

  [ Julian Andres Klode ]
  * debian/control{,.modules.in}:
    - Make me the new maintainer and move Kel to uploaders
    - Add Dm-Upload-Allowed
    - Remove VCS-* fields first, until the new repository has been created
    - Add information to description that pre-compiled modules may be available
    - Update the Standards Version to 3.8.0
  * debian/copyright: Follow machine-interpretable copyright
  * debian/patches/modules-build.diff: build correctly if only the modules
    target is built or in parallel (LP: #241547) (backported from SVN, r2670)
  * Build-Depend on quilt and add README.source

 -- Julian Andres Klode <jak@jak-linux.org>  Mon, 14 Jul 2008 21:56:42 +0200

ndiswrapper (1.52-1) unstable; urgency=low

  * New upstream release.
  * Rewrite debian/rules as a debhelper-cetric Makefile, rather than a cdbs
    dependent Makefile fragment. [debian/control, debian/rules]
  * Drop spurious dependencies of 'gcc' for ndiswrapper-source,
    '${perl:Depends}' for ndiswrapper-utils-1.9 and '${shlibs:Depends},
    ${perl:Depends}' for ndiswrapper-common. They were never used.

 -- Kel Modderman <kel@otaku42.de>  Thu, 07 Feb 2008 23:15:29 +1000

ndiswrapper (1.51-1) unstable; urgency=low

  * New upstream release
  * update standards version to 3.7.3, no changes necessary.

 -- Kel Modderman <kel@otaku42.de>  Sun, 23 Dec 2007 00:20:49 +1000

ndiswrapper (1.50-1) unstable; urgency=low

  * New upstream release.
  * Fix tarball name in README.Debian,
    s/ndiswrapper-source.tar.bz2/ndiswrapper.tar.bz2/.
  * Use relative dirname in debian/ndiswrapper-source.dirs

 -- Kel Modderman <kel@otaku42.de>  Fri, 30 Nov 2007 22:15:20 +1000

ndiswrapper (1.49-1) unstable; urgency=low

  * New upstream release.

 -- Kel Modderman <kel@otaku42.de>  Tue, 30 Oct 2007 20:29:05 +1000

ndiswrapper (1.49~rc4-1) unstable; urgency=low

  * New upstream release candidate.
  * Support for Linux 2.6.23. (Closes: #446359)
  * Use Homepage: field of debian control instead of pseudo standard with
    double spacing and paragraph break for each binary package.
  * Drop debian/patches/kbuild-only.patch, applied upstream.
  * Fix DIST_DESTDIR target in debian/rules.modules to prevent installation of
    module to "odd" path. (Closes: #395081)
  * Add Vcs debian/control tokens to reflect current maintenance archive.
  * Extended description no longer states that full kernel source is required
    to compile this module. It also capitalizes "linux". (Closes: #420688)
  * Recommend wireless-tools. (Closes: #444613)
  * Install debianized ndiswrapper tarball to /usr/src/ndiswrapper.tar.bz2 and
    not /usr/src/ndiswrapper-source.tar.bz2; this is a pseudo-guideline for
    module packages now.

 -- Kel Modderman <kel@otaku42.de>  Tue, 16 Oct 2007 16:12:01 +1000

ndiswrapper (1.47-2) unstable; urgency=low

  * Define KBUILD, KSRC and KVERS everytime we use upstream Makefile on module
    build to avoid failure due to increased sanity checking.

 -- Kel Modderman <kel@otaku42.de>  Mon, 02 Jul 2007 21:44:36 +1000



=== debian/control ===
Source: ndiswrapper
Section: misc
Priority: optional
Maintainer: Julian Andres Klode <jak@debian.org>
Uploaders: Kel Modderman <kel@otaku42.de>
Standards-Version: 3.8.4
Build-Depends: debhelper (>= 5), bzip2, dkms
Vcs-Git: git://git.debian.org/git/collab-maint/ndiswrapper.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/ndiswrapper.git;a=summary
Homepage: http://ndiswrapper.sourceforge.net/

Package: ndiswrapper-common
Architecture: all
Depends: ${misc:Depends}
Replaces: ndiswrapper-utils
Suggests: ndiswrapper-source
Description: Common scripts required to use the utilities for ndiswrapper
 Some vendors do not release specifications of the hardware or provide a
 Linux driver for their wireless network cards. This project implements
 Windows kernel API and NDIS (Network Driver Interface Specification) API
 within Linux kernel. A Windows driver for wireless network card is then
 linked to this implementation so that the driver runs natively, as though
 it is in Windows, without binary emulation.
 .
 This package contains wrapper scripts to call out to the proper
 versions of whatever -utils-X.X package is installed.

Package: ndiswrapper-utils-1.9
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, ndiswrapper-common
Recommends: ndiswrapper-dkms
Suggests: ndiswrapper-source
Description: Userspace utilities for the ndiswrapper Linux kernel module
 Some vendors do not release specifications of the hardware or provide a
 Linux driver for their wireless network cards. This project implements
 Windows kernel API and NDIS (Network Driver Interface Specification) API
 within Linux kernel. A Windows driver for wireless network card is then
 linked to this implementation so that the driver runs natively, as though
 it is in Windows, without binary emulation.
 .
 This package contains the userspace tools. You will also need the kernel
 module package.

Package: ndiswrapper-source
Architecture: all
Section: kernel
Depends: ${misc:Depends}, module-assistant, debhelper (>= 5), bzip2
Suggests: kernel-package
Description: Source for the ndiswrapper Linux kernel module
 Some vendors do not release specifications of the hardware or provide a
 Linux driver for their wireless network cards. This project implements
 Windows kernel API and NDIS (Network Driver Interface Specification) API
 within Linux kernel. A Windows driver for wireless network card is then
 linked to this implementation so that the driver runs natively, as though
 it is in Windows, without binary emulation.
 .
 This package provides the source code for the ndiswrapper kernel module.

Package: ndiswrapper-dkms
Architecture: all
Section: kernel
Depends: ${misc:Depends}
Description: Source for the ndiswrapper Linux kernel module (DKMS)
 Some vendors do not release specifications of the hardware or provide a
 Linux driver for their wireless network cards. This project implements
 Windows kernel API and NDIS (Network Driver Interface Specification) API
 within Linux kernel. A Windows driver for wireless network card is then
 linked to this implementation so that the driver runs natively, as though
 it is in Windows, without binary emulation.
 .
 This package provides the source code for ndiswrapper kernel module to be
 build with dkms.

## ndiswrapper 1.56+r2729

=== driver/Makefile ===
--- 
+++ 
@@ -25,8 +25,10 @@
 
 # Kernel Makefile doesn't always know the exact kernel version, so we
 # get it from the kernel headers instead and pass it to make.
-
+VERSION_H := $(KBUILD)/include/generated/utsrelease.h
+ifeq (,$(wildcard $(VERSION_H)))
 VERSION_H := $(KBUILD)/include/linux/utsrelease.h
+endif
 ifeq (,$(wildcard $(VERSION_H)))
 VERSION_H := $(KBUILD)/include/linux/version.h
 endif
@@ -35,6 +37,10 @@
 endif
 
 KVERS := $(shell sed -ne 's/"//g;s/^\#define UTS_RELEASE //p' $(VERSION_H))
+
+ifeq (,$(KVERS))
+$(error Cannot find UTS_RELEASE in $(VERSION_H), has 'make modules_prepare' been called?)
+endif
 
 ifdef DIST_DESTDIR
 DESTDIR = $(DIST_DESTDIR)

=== utils/Makefile ===
DESTDIR =
sbindir = $(DESTDIR)/sbin
usrsbindir = $(DESTDIR)/usr/sbin

DRIVER_DIR ?= ../driver

CC = gcc
CFLAGS = -g -Wall -I$(DRIVER_DIR)

DISTFILES=Makefile ndiswrapper loadndisdriver.c ndiswrapper-buginfo

all: loadndisdriver

loadndisdriver: loadndisdriver.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<

clean:
	rm -f *~ *.o loadndisdriver

distclean: clean
	rm -f .\#*

install: all
	install -D -m 755 loadndisdriver $(sbindir)/loadndisdriver
	install -D -m 755 ndiswrapper $(usrsbindir)/ndiswrapper
	install -D -m 755 ndiswrapper-buginfo $(usrsbindir)/ndiswrapper-buginfo
	@echo
	@echo "NOTE: Windows driver configuration file format has changed since" \
	      "1.5. You must re-install Windows drivers if they were" \
	      "installed before."

dist:
	@for file in $(DISTFILES); do \
	  cp  $$file $(distdir)/$$file; \
	done

=== debian/changelog ===
ndiswrapper (1.56+r2729-1) unstable; urgency=low

  * Imported Upstream version 1.56+r2729
    - Support for Kernels 2.6.36 - 2.6.38 (LP: #660664, Closes: #604880)
  * Drop patch for Linux 2.6.35, included in snapshot

 -- Julian Andres Klode <jak@debian.org>  Mon, 14 Mar 2011 15:21:40 +0100

ndiswrapper (1.56-3) unstable; urgency=low

  * Use a reworked and working Linux 2.6.35 support patch (LP: #613796)

 -- Julian Andres Klode <jak@debian.org>  Mon, 13 Sep 2010 19:59:08 +0200

ndiswrapper (1.56-2) unstable; urgency=low

  * Only suggest ndiswrapper-dkms on Ubuntu
  * Add support for Linux 2.6.35 (LP: #590090)
  * Set Standards-Version to 3.9.1

 -- Julian Andres Klode <jak@debian.org>  Tue, 03 Aug 2010 14:21:33 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Julian Andres Klode <jak@debian.org>
 Uploaders: Kel Modderman <kel@otaku42.de>
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Build-Depends: debhelper (>= 5), bzip2, dkms
 Vcs-Git: git://git.debian.org/git/collab-maint/ndiswrapper.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/ndiswrapper.git;a=summary
@@ -28,8 +28,8 @@
 Package: ndiswrapper-utils-1.9
 Architecture: i386 amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}, ndiswrapper-common
-Recommends: ndiswrapper-dkms
-Suggests: ndiswrapper-source
+Recommends: ${distro:Recommends}
+Suggests: ${distro:Suggests}, ndiswrapper-source
 Description: Userspace utilities for the ndiswrapper Linux kernel module
  Some vendors do not release specifications of the hardware or provide a
  Linux driver for their wireless network cards. This project implements

=== debian/rules ===
#!/usr/bin/make -f
version := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
recommends := $(shell dpkg-vendor --derives-from Ubuntu || echo "ndiswrapper-dkms")
suggests := $(shell dpkg-vendor --derives-from Ubuntu && echo "ndiswrapper-dkms" || true)
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-indep build-arch

build-indep: build-indep-stamp
build-indep-stamp:
	touch $@

build-arch: build-arch-stamp
build-arch-stamp:
	dh_testdir

	$(MAKE) -C utils

	touch $@

clean:
	dh_testdir
	dh_testroot

	$(MAKE) -C utils distclean

	dh_clean build-arch-stamp build-indep-stamp debian/ndiswrapper-dkms.dkms

debian/ndiswrapper-dkms.dkms: debian/ndiswrapper-dkms.dkms.in
	sed s/@VERSION@/$(version)/g $< > $@

install: install-indep install-arch

install-indep: build-indep debian/ndiswrapper-dkms.dkms
	dh_testdir
	dh_testroot
	dh_clean -k -i
	dh_installdirs -i
	dh_install -i

	install -D -m 0755 debian/rules.modules \
		debian/tmp/modules/ndiswrapper/debian/rules

	for f in *.modules.in control compat copyright changelog; do \
		install -m 0644 debian/$$f \
			debian/tmp/modules/ndiswrapper/debian/; \
	done

	install driver/Makefile driver/*.[chS] driver/*.sh \
		debian/tmp/modules/ndiswrapper/

	mkdir -p debian/ndiswrapper-source/usr/src/
	tar jcf debian/ndiswrapper-source/usr/src/ndiswrapper.tar.bz2 \
		-C debian/tmp modules

	# Create the ndiswrapper-dkms package.
	dh_install -pndiswrapper-dkms driver/Makefile usr/src/ndiswrapper-$(version)
	dh_install -pndiswrapper-dkms driver/*.[chS]  usr/src/ndiswrapper-$(version)
	dh_install -pndiswrapper-dkms driver/*.sh     usr/src/ndiswrapper-$(version)
	dh_dkms -pndiswrapper-dkms

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_clean -k -s

	install -D -m755 utils/loadndisdriver \
		debian/ndiswrapper-utils-1.9/sbin/loadndisdriver-1.9
	install -D -m755 utils/ndiswrapper \
		debian/ndiswrapper-utils-1.9/usr/sbin/ndiswrapper-1.9
	install -D -m644 loadndisdriver.8 \
		debian/ndiswrapper-utils-1.9/usr/share/man/man8/loadndisdriver-1.9.8
	install -D -m644 ndiswrapper.8 \
		debian/ndiswrapper-utils-1.9/usr/share/man/man8/ndiswrapper-1.9.8

binary-indep: build-indep install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installman -i
	dh_installdocs -i
	dh_installchangelogs -i ChangeLog
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i -- -Vdistro:Recommends=$(recommends) \
	                    -Vdistro:Suggests=$(suggests)
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build-arch install-arch
	dh_testdir -s
	dh_testroot -s
	dh_installman -s
	dh_installdocs -s
	dh_installchangelogs -s ChangeLog
	dh_strip -s
	dh_compress -s
	dh_fixperms -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s -- -Vdistro:Recommends=$(recommends) \
	                    -Vdistro:Suggests=$(suggests)
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean install install-indep install-arch binary-indep binary-arch binary

## ndiswrapper 1.57~rc1

=== Makefile ===
DRIVER_VERSION = $(shell sed -n 's/^\#define[ \t]\+DRIVER_VERSION[ \t]\+"\([^"]\+\)"/\1/p' driver/ndiswrapper.h)

UTILS_VERSION = $(shell sed -n 's/^\#define[ \t]\+UTILS_VERSION[ \t]\+"\([^"]\+\)"/\1/p' driver/ndiswrapper.h)

distdir=ndiswrapper-${DRIVER_VERSION}
distarchive=${distdir}.tar.gz

DISTFILES=AUTHORS ChangeLog INSTALL Makefile README ndiswrapper.spec \
				   ndiswrapper.8 loadndisdriver.8
SUBDIRS = utils driver

ifeq ($(wildcard /usr/share/man)$(wildcard /usr/man),/usr/man)
mandir = /usr/man
else
mandir = /usr/share/man
endif

KVERS ?= $(shell uname -r)

.PHONY: all
all: $(SUBDIRS)

.PHONY: $(SUBDIRS)
$(SUBDIRS):
	$(MAKE) -C $@

.PHONY: install
install:
	$(MAKE) -C driver install
	$(MAKE) -C utils install
	mkdir -p -m 0755 $(DESTDIR)$(mandir)/man8
	install -m 644 ndiswrapper.8 $(DESTDIR)$(mandir)/man8
	install -m 644 loadndisdriver.8 $(DESTDIR)$(mandir)/man8

.PHONY: clean distclean
clean:
	$(MAKE) -C driver clean
	$(MAKE) -C utils clean
	rm -f *~
	rm -fr ${distdir} ${distdir}.tar.gz patch-stamp

distclean: clean
	$(MAKE) -C driver distclean
	$(MAKE) -C utils distclean
	rm -f .\#*

uninstall:
	rm -f $(DESTDIR)$(mandir)/man8/ndiswrapper.8
	rm -f $(DESTDIR)$(mandir)/man8/loadndisdriver.8
	$(MAKE) -C driver uninstall
	$(MAKE) -C utils uninstall

dist:
	@rm -rf ${distdir}
	mkdir -p ${distdir}
	@for file in $(DISTFILES); do \
	  cp $$file $(distdir)/$$file || exit 1; \
	done
	for subdir in $(SUBDIRS); do \
	  if test "$$subdir" = .; then :; else \
	    test -d $(distdir)/$$subdir \
	    || mkdir $(distdir)/$$subdir \
	    || exit 1; \
	  fi; \
	done
	$(MAKE) -C driver distdir=../${distdir}/driver dist
	$(MAKE) -C utils distdir=../${distdir}/utils dist

	# Update version in dist rpm spec file
	sed "s/\%define\s\+ndiswrapper_version\s\+[^\}]\+\}/%define ndiswrapper_version $(DRIVER_VERSION)\}/" \
		ndiswrapper.spec >$(distdir)/ndiswrapper.spec
	tar cfz ${distarchive} ${distdir}

rpm: dist ndiswrapper.spec
	rpmbuild -ta $(distarchive) --define="ndiswrapper_version $(DRIVER_VERSION)"

=== driver/Makefile ===
--- 
+++ 
@@ -6,8 +6,8 @@
 	loader.h longlong.h mkexport.sh mkstubs.sh ndis.c ndis.h \
 	ndiswrapper.h ntoskernel.c ntoskernel.h ntoskernel_io.c pe_linker.c \
 	pe_linker.h pnp.c pnp.h proc.c rtl.c usb.c usb.h win2lin_stubs.S \
-	winnt_types.h workqueue.c wrapmem.h wrapmem.c wrapper.c wrapper.h \
-	wrapndis.c wrapndis.h
+	winnt_types.h workqueue.c wrapmem.c wrapmem.h wrapndis.c wrapndis.h \
+	wrapper.c wrapper.h
 
 # By default, we try to compile the modules for the currently running
 # kernel.  But it's the first approximation, as we will re-read the
@@ -42,13 +42,7 @@
 $(error Cannot find UTS_RELEASE in $(VERSION_H), has 'make modules_prepare' been called?)
 endif
 
-ifdef DIST_DESTDIR
-DESTDIR = $(DIST_DESTDIR)
-else
-DESTDIR ?= /
-endif
-
-INST_DIR ?= $(shell echo $(DESTDIR)/lib/modules/$(KVERS)/misc | sed 's^//^/^g')
+INST_DIR = /lib/modules/$(KVERS)/misc
 
 SRC_DIR=$(shell pwd)
 
@@ -66,53 +60,47 @@
 EXTRA_CFLAGS += -DDEBUG=$(DEBUG) -g
 endif
 
-# to debug timers, add option "TIMER_DEBUG=1 DEBUG=<n>"
+# to debug timers, add option "TIMER_DEBUG=1"
 ifdef TIMER_DEBUG
 EXTRA_CFLAGS += -DTIMER_DEBUG
 endif
 
-# to debug event layer, add option "EVENT_DEBUG=1 DEBUG=<n>"
+# to debug event layer, add option "EVENT_DEBUG=1"
 ifdef EVENT_DEBUG
 EXTRA_CFLAGS += -DEVENT_DEBUG
 endif
 
-# to debug USB layer, add option "USB_DEBUG=1 DEBUG=<n>"
+# to debug USB layer, add option "USB_DEBUG=1"
 ifdef USB_DEBUG
 EXTRA_CFLAGS += -DUSB_DEBUG
 endif
 
-# to debug I/O layer, add option "IO_DEBUG=1 DEBUG=<n>"
+# to debug I/O layer, add option "IO_DEBUG=1"
 ifdef IO_DEBUG
 EXTRA_CFLAGS += -DIO_DEBUG
 endif
 
-# to debug worker threads
+# to debug worker threads, add option "WORK_DEBUG=1"
 ifdef WORK_DEBUG
 EXTRA_CFLAGS += -DWORK_DEBUG
 endif
 
-# to debug memory allocation issues
+# to debug memory allocation, add option "ALLOC_DEBUG=<n>" where <n> is 1 to 3
 ifdef ALLOC_DEBUG
 EXTRA_CFLAGS += -DALLOC_DEBUG=$(ALLOC_DEBUG)
 endif
 
-# emulate (pseudo) preemption
-ifdef WRAP_PREEMPT
-EXTRA_CFLAGS += -DWRAP_PREEMPT
-endif
-
 OBJS = crt.o hal.o iw_ndis.o loader.o ndis.o ntoskernel.o ntoskernel_io.o \
 	pe_linker.o pnp.o proc.o rtl.o wrapmem.o wrapndis.o wrapper.o
 
-EXPORTS = crt_exports.h hal_exports.h ndis_exports.h ntoskernel_exports.h \
-	ntoskernel_io_exports.h rtl_exports.h
+EXPORT_SRCS = crt.c hal.c ndis.c ntoskernel.c ntoskernel_io.c rtl.c
 
 STUB_SRCS = crt.c hal.c ndis.c ntoskernel.c ntoskernel_io.c \
 	pnp.c rtl.c wrapndis.c
 
 
 # By default, USB layer is compiled in if USB support is in kernel;
-# to disable USB support in ndiswrapper even if USB support is in kenrel,
+# to disable USB support in ndiswrapper even if USB support is in kernel,
 # add option "DISABLE_USB=1"
 ifndef DISABLE_USB
 ifeq ($(CONFIG_USB),y)
@@ -124,7 +112,7 @@
 endif
 
 ifdef ENABLE_USB
-EXPORTS += usb_exports.h
+EXPORT_SRCS += usb.c
 STUB_SRCS += usb.c
 OBJS += usb.o
 EXTRA_CFLAGS += -DENABLE_USB
@@ -142,11 +130,11 @@
 quiet_cmd_mkexport = MKEXPORT $@
 cmd_mkexport = $(SHELL) $(obj)/mkexport.sh $< $@
 
-extra-y += $(EXPORTS)
+extra-y += $(EXPORT_SRCS:.c=_exports.h)
 %_exports.h: %.c $(obj)/mkexport.sh FORCE
 	$(call if_changed,mkexport)
 
-$(addprefix $(obj)/,$(EXPORTS:_exports.h=.o)): %.o: %_exports.h
+$(addprefix $(obj)/,$(EXPORT_SRCS:.c=.o)): %.o: %_exports.h
 
 ifeq ($(CONFIG_X86_64),y)
 quiet_cmd_mkstubs = MKSTUBS $@
@@ -195,22 +183,30 @@
 modules:
 	$(MAKE) -C $(KBUILD) M=$(SRC_DIR)
 
+$(MODULE):
+	$(MAKE) modules
+
 clean:
 	rm -f *.o *.ko .*.cmd *.mod.c *.symvers modules.order *~ .\#*
 	rm -f *_exports.h win2lin_stubs.h
 	rm -rf .tmp_versions
 
-install: config_check modules
-	echo $(INST_DIR)
-	mkdir -p $(INST_DIR)
-	install -m 0644 $(MODULE) $(INST_DIR)
-ifndef DIST_DESTDIR
-	-/sbin/depmod -a $(KVERS) -b $(DESTDIR)
+install: config_check $(MODULE)
+	mkdir -p -m 0755 $(DESTDIR)$(INST_DIR)
+	install -m 0644 $(MODULE) $(DESTDIR)$(INST_DIR)
+ifndef DESTDIR
+	-/sbin/depmod -a $(KVERS)
+endif
+
+uninstall:
+	rm -f $(DESTDIR)$(INST_DIR)/$(MODULE)
+ifndef DESTDIR
+	-/sbin/depmod -a $(KVERS)
 endif
 
 dist:
 	@for file in $(DISTFILES); do \
-		cp $$file $(distdir)/$$file; \
+		cp $$file $(distdir)/$$file || exit 1; \
 	done
 
 .PHONY: all modules clean install config_check dist

=== utils/Makefile ===
sbindir = /sbin
usrsbindir = /usr/sbin

DRIVER_DIR ?= ../driver

CC = gcc
CFLAGS = -g -Wall -I$(DRIVER_DIR)

DISTFILES=Makefile ndiswrapper loadndisdriver.c ndiswrapper-buginfo

all: loadndisdriver

loadndisdriver: loadndisdriver.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<

clean:
	rm -f *~ *.o loadndisdriver

distclean: clean
	rm -f .\#*

install: all
	mkdir -p -m 755 $(DESTDIR)$(sbindir)
	mkdir -p -m 755 $(DESTDIR)$(usrsbindir)
	install -m 755 loadndisdriver $(DESTDIR)$(sbindir)
	install -m 755 ndiswrapper $(DESTDIR)$(usrsbindir)
	install -m 755 ndiswrapper-buginfo $(DESTDIR)$(usrsbindir)
	@echo
	@echo "NOTE: Windows driver configuration file format has changed since" \
	      "1.5. You must re-install Windows drivers if they were" \
	      "installed before."

uninstall:
	rm -f $(DESTDIR)$(sbindir)/loadndisdriver
	rm -f $(DESTDIR)$(usrsbindir)/ndiswrapper
	rm -f $(DESTDIR)$(usrsbindir)/ndiswrapper-buginfo

dist:
	@for file in $(DISTFILES); do \
	  cp $$file $(distdir)/$$file || exit 1; \
	done

=== debian/changelog ===
ndiswrapper (1.57~rc1-1) unstable; urgency=low

  * Imported Upstream version 1.57~rc1
    - Fixes build with newer kernel version (Closes: #650012)
  * Set Standards-Version to 3.9.2

 -- Julian Andres Klode <jak@debian.org>  Fri, 25 Nov 2011 16:45:32 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Julian Andres Klode <jak@debian.org>
 Uploaders: Kel Modderman <kel@otaku42.de>
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Build-Depends: debhelper (>= 5), bzip2, dkms
 Vcs-Git: git://git.debian.org/git/collab-maint/ndiswrapper.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/ndiswrapper.git;a=summary

## ndiswrapper 1.57

=== driver/Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 MODNAME = ndiswrapper
 
 DISTFILES = \
-	Makefile crt.c divdi3.c hal.c iw_ndis.c iw_ndis.h lin2win.h loader.c \
-	loader.h longlong.h mkexport.sh mkstubs.sh ndis.c ndis.h \
+	Makefile crt.c divdi3.c hal.c iw_ndis.c iw_ndis.h lin2win.S lin2win.h \
+	loader.c loader.h longlong.h mkexport.sh mkstubs.sh ndis.c ndis.h \
 	ndiswrapper.h ntoskernel.c ntoskernel.h ntoskernel_io.c pe_linker.c \
 	pe_linker.h pnp.c pnp.h proc.c rtl.c usb.c usb.h win2lin_stubs.S \
 	winnt_types.h workqueue.c wrapmem.c wrapmem.h wrapndis.c wrapndis.h \
@@ -85,7 +85,7 @@
 EXTRA_CFLAGS += -DWORK_DEBUG
 endif
 
-# to debug memory allocation, add option "ALLOC_DEBUG=<n>" where <n> is 1 to 3
+# to debug memory allocation, add option "ALLOC_DEBUG=<n>" where <n> is 1 or 2
 ifdef ALLOC_DEBUG
 EXTRA_CFLAGS += -DALLOC_DEBUG=$(ALLOC_DEBUG)
 endif
@@ -145,7 +145,7 @@
 	$(call if_changed,mkstubs)
 
 $(obj)/win2lin_stubs.o: $(obj)/win2lin_stubs.h
-OBJS += win2lin_stubs.o
+OBJS += win2lin_stubs.o lin2win.o
 else
 OBJS += divdi3.o
 endif
@@ -192,7 +192,9 @@
 	rm -rf .tmp_versions
 
 install: config_check $(MODULE)
-	mkdir -p -m 0755 $(DESTDIR)$(INST_DIR)
+	@/sbin/modinfo $(MODULE) | grep -q "^vermagic: *$(KVERS) " || \
+		{ echo "$(MODULE)" is not for Linux $(KVERS); exit 1; }
+	mkdir -p -m 755 $(DESTDIR)$(INST_DIR)
 	install -m 0644 $(MODULE) $(DESTDIR)$(INST_DIR)
 ifndef DESTDIR
 	-/sbin/depmod -a $(KVERS)

=== debian/changelog ===
ndiswrapper (1.57-1ubuntu1) precise; urgency=low

  * patch from  Joerg Schirottke <master@kanotix.com> to fix (LP: #978920)
   - patches/kernel-3-userspace-support.patch: Allow kernel 3.0+
   - Fix debian/ndiswrapper-dkms.dkms.in

 -- Oliver Grawert <ogra@ubuntu.com>  Thu, 12 Apr 2012 16:16:51 +0200

ndiswrapper (1.57-1) unstable; urgency=low

  * Imported Upstream version 1.57
    - Fixes build with kernel 3.2 (Closes: #655223, LP: #910597)
  * Enable hardening build flags (Closes: #655249)
  * patches/ndiswrapper-harden.patch: Use $(shell X) instead of `X`
  * Update to Policy 3.9.3, copyright-format 1.0

 -- Julian Andres Klode <jak@debian.org>  Mon, 05 Mar 2012 16:49:02 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Julian Andres Klode <jak@debian.org>
 Uploaders: Kel Modderman <kel@otaku42.de>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Build-Depends: debhelper (>= 5), bzip2, dkms
 Vcs-Git: git://git.debian.org/git/collab-maint/ndiswrapper.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/ndiswrapper.git;a=summary

## ndiswrapper 1.58~rc1

=== debian/changelog ===
ndiswrapper (1.58~rc1-0ubuntu1) raring; urgency=low

  * New upstream release. (LP: #1023645)
   - add a patch to fix for 3.6+ kernels, maybe.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Thu, 20 Dec 2012 22:44:06 +0000

## ndiswrapper 1.58

=== debian/changelog ===
ndiswrapper (1.58-2) unstable; urgency=low

  * Add Support for Kernel 3.10; patch by Canonical (Closes: #717152)
  * Update Ubuntu patch to re-add support for older kernels

 -- Julian Andres Klode <jak@debian.org>  Sun, 04 Aug 2013 13:41:30 +0200

ndiswrapper (1.58-1) unstable; urgency=low

  * Imported Upstream version 1.58 (Closes: #707665)
  * Use $KERNELRELEASE as target kernel version (Closes: #693638)
  * Add BUILT_MODULE_NAME to dkms config file (Workaround for: #690747)
  * Add support for kernel 3.9
  * Patch userland for 3.X kernels
  * Set Standards-Version to 3.9.4

 -- Julian Andres Klode <jak@debian.org>  Sun, 14 Jul 2013 20:02:35 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Julian Andres Klode <jak@debian.org>
 Uploaders: Kel Modderman <kel@otaku42.de>
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Build-Depends: debhelper (>= 5), bzip2, dkms
 Vcs-Git: git://git.debian.org/git/collab-maint/ndiswrapper.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/ndiswrapper.git;a=summary
